// Generated by CoffeeScript 1.12.8
(function() {
  var BufferStream, Stream, fn, isArray, isBuffer, ref, split,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  Stream = require('stream').Stream;

  fn = require('./fn');

  ref = [Array.isArray, Buffer.isBuffer], isArray = ref[0], isBuffer = ref[1];

  split = function() {
    var buflen, can_split, cur, found, i, j, len, pos, ref1, ref2, rest, results, splitter;
    if (!this.buffer.length) {
      return;
    }
    can_split = this.enabled && this.splitters.length;
    results = [];
    while (can_split) {
      cur = null;
      pos = buflen = this.buffer.length;
      ref1 = this.splitters;
      for (j = 0, len = ref1.length; j < len; j++) {
        splitter = ref1[j];
        if (buflen < splitter.length) {
          continue;
        }
        i = fn.indexOf.call(this.buffer, splitter);
        if (i !== -1 && i < pos && i < buflen) {
          cur = splitter;
          pos = i;
        }
      }
      can_split = cur !== null;
      if (!can_split) {
        break;
      }
      ref2 = fn.split(this.buffer, pos, cur.length), found = ref2[0], rest = ref2[1];
      this.buffer = rest;
      this.emit('split', found, cur);
      if (this.paused || !this.enabled || this.buffer.length === 0) {
        break;
      } else {
        results.push(void 0);
      }
    }
    return results;
  };

  BufferStream = (function(superClass) {
    extend(BufferStream, superClass);

    function BufferStream(opts) {
      if (opts == null) {
        opts = {};
      }
      this.reset = bind(this.reset, this);
      this.clear = bind(this.clear, this);
      this.write = bind(this.write, this);
      this.split = bind(this.split, this);
      this.disable = bind(this.disable, this);
      this.enable = bind(this.enable, this);
      this.setSize = bind(this.setSize, this);
      this.setEncoding = bind(this.setEncoding, this);
      this.toString = bind(this.toString, this);
      this.getBuffer = bind(this.getBuffer, this);
      if (typeof opts === 'string') {
        opts = {
          encoding: opts
        };
      }
      if (opts.size == null) {
        opts.size = 'none';
      }
      if (opts.encoding == null) {
        opts.encoding = null;
      }
      if (opts.blocking == null) {
        opts.blocking = true;
      }
      this.size = opts.size;
      this.blocking = opts.blocking;
      this.splitters = [];
      this.__defineGetter__('length', (function(_this) {
        return function() {
          return _this.buffer.length;
        };
      })(this));
      this.setEncoding(opts.encoding);
      this.enabled = true;
      this.writable = true;
      this.readable = true;
      this.finished = false;
      this.paused = false;
      this.reset();
      BufferStream.__super__.constructor.call(this);
      if (opts.split != null) {
        if (isArray(opts.split)) {
          this.split(opts.split);
        } else {
          this.split(opts.split, function(data) {
            return this.emit('data', data);
          });
        }
      }
      if (opts.disabled) {
        this.disable();
      }
    }

    BufferStream.prototype.getBuffer = function() {
      return this.buffer;
    };

    BufferStream.prototype.toString = function() {
      var ref1;
      return (ref1 = this.buffer).toString.apply(ref1, arguments);
    };

    BufferStream.prototype.setEncoding = function(encoding1) {
      this.encoding = encoding1;
    };

    BufferStream.prototype.setSize = function(size) {
      this.size = size;
      if (!this.paused && this.size === 'none') {
        return this.clear();
      }
    };

    BufferStream.prototype.enable = function() {
      return this.enabled = true;
    };

    BufferStream.prototype.disable = function() {
      var args, i, j, len, splitter;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      if (args.length === 1 && isArray(args[0])) {
        args = args[0];
      }
      for (j = 0, len = args.length; j < len; j++) {
        splitter = args[j];
        i = this.splitters.indexOf(splitter);
        if (i === -1) {
          continue;
        }
        this.splitters.splice(i, 1);
        if (!this.splitters.length) {
          break;
        }
      }
      if (!this.splitters.length) {
        this.enabled = false;
      }
      if (!args.length) {
        this.enabled = false;
        if (!this.paused) {
          return this.clear();
        }
      }
    };

    BufferStream.prototype.split = function() {
      var args, callback, splitter;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      if (args.length === 1 && isArray(args[0])) {
        args = args[0];
      }
      if (args.length === 2 && typeof args[1] === 'function') {
        splitter = args[0], callback = args[1];
        this.splitters.push(splitter);
        return this.on('split', function(_, token) {
          if (token === splitter) {
            return callback.apply(this, arguments);
          }
        });
      }
      return this.splitters = this.splitters.concat(args);
    };

    BufferStream.prototype.write = function(buffer, encoding) {
      if (!this.writable) {
        this.emit('error', new Error("Stream is not writable."));
        return false;
      }
      if (isBuffer(buffer)) {

      } else if (typeof buffer === 'string') {
        buffer = Buffer.from(buffer, encoding != null ? encoding : this.encoding);
      } else {
        this.emit('error', new Error("Argument should be either a buffer or a string."));
      }
      if (this.buffer.length === 0) {
        this.buffer = buffer;
      } else {
        this.buffer = fn.concat(this.buffer, buffer);
      }
      if (this.paused) {
        return false;
      }
      if (this.size === 'none') {
        if (this.enabled) {
          split.call(this);
        }
        return this.clear();
      } else if (this.size === 'flexible') {
        if (this.enabled) {
          split.call(this);
        }
        if (this.finished) {
          return this.clear();
        }
        if (this.blocking) {
          if (!this.enabled) {
            this.clear();
          }
          return true;
        } else {
          process.nextTick((function(_this) {
            return function() {
              return _this.emit('drain');
            };
          })(this));
          return false;
        }
      } else {
        throw new Error("not implemented yet :(");
      }
    };

    BufferStream.prototype.clear = function() {
      var buffer;
      if (!this.buffer.length) {
        return true;
      }
      buffer = this.buffer;
      this.reset();
      this.emit('data', buffer);
      return !this.paused;
    };

    BufferStream.prototype.reset = function() {
      if (typeof this.size === 'number') {
        return this.buffer = Buffer.alloc(this.size);
      } else {
        return this.buffer = Buffer.alloc(0);
      }
    };

    BufferStream.prototype.pause = function() {
      if (this.paused) {
        return;
      }
      this.paused = true;
      return this.emit('pause');
    };

    BufferStream.prototype.resume = function() {
      if (!this.paused) {
        return;
      }
      this.paused = false;
      split.call(this);
      if (this.paused) {
        return;
      }
      if (!this.enabled || this.size === 'none' || this.finished) {
        if (!this.clear()) {
          return;
        }
      }
      this.emit('drain');
      if (this.size === 'none') {
        this.emit('resume');
      }
      if (this.finished) {
        this.emit('end');
        return this.emit('close');
      }
    };

    BufferStream.prototype.end = function(data, encoding) {
      if (this.finished) {
        return;
      }
      this.finished = true;
      if (data != null) {
        this.write(data, encoding);
      }
      this.writable = false;
      if (!this.paused) {
        this.emit('end');
        return this.emit('close');
      }
    };

    return BufferStream;

  })(Stream);

  BufferStream.fn = fn;

  module.exports = BufferStream;

}).call(this);
